<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div class="mt-1 relative rounded-sm shadow-sm">
            <div
                class="flex justify-between space-x-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full items-center"
            >
                <div
                    class="flex-1 grid grid-cols-5 items-center"
                >
                    <div class="col-span-2">
                        <div class="relative w-full">
                            <select
                                v-model="hour"
                                :disabled="disabled || readonly"
                                class="form-control !rounded-tr-none !rounded-br-none !border-r-0"
                                :class="{
                                    'disabled': disabled || readonly,
                                }"
                            >
                                <option
                                    value=""
                                    :selected="String(hour) === ''"
                                >
                                    {{ placeholder || '-' }}
                                </option>
                                <option
                                    v-for="i in [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]"
                                    :key="`${name}-${i}`"
                                    :value="i"
                                    :selected="String(data) === String(i)"
                                >
                                    {{ ('0' + i).slice(-2) }}
                                </option>
                            </select>
                            <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700">
                                <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                            </div>
                        </div>
                    </div>
                    <div class="text-center form-control !rounded-none">:</div>
                    <div class="col-span-2">
                        <div class="relative text-center">
                            <select
                                v-model="minute"
                                :disabled="disabled || readonly"
                                class="form-control !rounded-tl-none !rounded-bl-none !border-l-0"
                                :class="{
                                    'disabled': disabled || readonly,
                                }"
                            >
                                <option
                                    value=""
                                    :selected="String(hour) === '' || hour === null || hour === 'null' || isNaN(hour)"
                                >
                                    {{ placeholder || '-' }}
                                </option>
                                <option
                                    v-for="i in [0,5,10,15,20,25,30,35,40,45,50,55]"
                                    :key="`${name}-${i}`"
                                    :value="i"
                                    :selected="String(data) === String(i)"
                                >
                                    {{ ('0' + i).slice(-2) }}
                                </option>
                            </select>
                            <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700">
                                <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {onMounted, ref, watch} from 'vue';
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    prependIcon: {
        required: false,
        type: String,
        default: null,
    },
    appendIcon: {
        required: false,
        type: String,
        default: null,
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    fund: {
        required: false,
        type: Boolean,
        default: false,
    },
    number: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue']);

const hour = ref('');
const minute = ref('');

onMounted(() => {
    if (data.value && data.value.length) {
        let s = data.value.split(':');
        if (typeof s[0] !== 'undefined') {
            hour.value = parseInt(s[0]);
        }
        if (typeof s[1] !== 'undefined') {
            minute.value = parseInt(s[1]);
        }
    }
});

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});

watch(hour, (newValue) => {
    let s = '';
    s += ('00' + newValue).slice(-2);
    s += ':';
    s += ('00' + minute.value).slice(-2);

    data.value = s;
});
watch(minute, (newValue) => {
    let s = '';
    s += ('00' + hour.value).slice(-2);
    s += ':';
    s += ('00' + newValue).slice(-2);

    data.value = s;
});
</script>
